<?php
/*
	Copyright 2010 Ketil Tunheim. This file is part of Magic Fretboard.

    Magic Fretboard is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Magic Fretboard is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

//
// part one: constants
//

// define stuff
define('NL','');
//define('NL',chr(10).chr(13));
define('TH','http://chord.cerapter.net/scale_view.php');
define('ST','step');
define('TU','tune');
define('IN','int_');
define('PF','gt_');

// log on, and get the functions// koble til databasen
mysql_connect("<localhost/address>", "<user>", "<pass>") || die(mysql_error()); 
mysql_select_db("<db>") || die("Kan ikke koble til databasen"); 
include_once('./scale_functions.php');

// no warning by default
$info = "<br />";
$type_def = 'enharmonic';
$display_def = 'universal';
$temperament_def = '12edo';

// start session
session_start();

// dare you try the 31edo? you'll have to use a fretless instrument...
if ($_SESSION['temperament'] or $_REQUEST['temperament']) {
	$temperament = ($_SESSION['temperament']) ? $_SESSION['temperament'] : $_REQUEST['temperament'];
} else {
	$temperament = $temperament_def;
}
switch ($temperament) {
	case '31edo':
		require('./tem_31edo.php');
		break;
	case '12edo': default:
		require('./tem_12edo.php');
		break;
}

//
// part two: custom settings
//

// now for getting the intended scale and tuning and root
// these blocks used to be huge, but now they're in scale_functions.php
if ($_REQUEST['temperament']) {
	$_SESSION['temperament'] = $_REQUEST['temperament'];
}
if (!isset($_SESSION['step0']) or $_REQUEST['reset'] == 'y')
{
	// get the standard getup
	reset_session();
}
else if ($_REQUEST['reset'] == 'n' or ($_GET['tuning'] and $_GET['scale']))
{
	// update the data
	set_session();
}
else if ($_REQUEST['newroot'])
{
	// transpose and update
	skew_session($info);
}
else if ($_REQUEST['1'])
{
	// add or remove an interval
	uncheck_ints();
}

// no more session for now
session_write_close();

//
// part three: generating the data for the page
//

// load variables from the session and into simpler ones
$string_count	= $_SESSION['strings'];
$scale_steps	= $_SESSION['scale_steps'];
$root			= $_SESSION['root'];
$type = ($_SESSION['type']) ? $_SESSION['type'] : $type_def;
$display = ($_SESSION['display_type']) ? $_SESSION['display_type'] : $display_def;

$tuning = array();
$scale = array();
$interv = array();
for ($i = 0; $i < $string_count; $i++)	$tuning[$i]	= $_SESSION[TU.$i];
for ($i = 0; $i < $scale_steps; $i++)	$scale[$i]	= $_SESSION[ST.$i];
foreach ($intervals_all as $i => $ints)	$interv[$i]	= $_SESSION[IN.$ints];

// and what is the root's name? I might want to use this later
$root_name	= substr($notes_all[$root],0,-1);
$root_octv	= substr($notes_all[$root],-1);
$key_text	= 'The current key is ' . $root_name . '<sub>' . $root_octv . '</sub><br />';

// what intervals are in this scale, anyway? this is for the checkboxes
$intervals = array();
// first, which of the steps is the root?
$root_pos = array_search($root%12, $scale);
$root_val = $scale[$root_pos];
// get the intervals one by one
foreach ($scale as $key => $step) {	
	// subtract the root from everything else to find ITS intervals
	$position = ($step - $root_val) % $octave;
	// but make sure they're in the (0-11) zone
	while ($position < 0) {
		$position += $octave;
	}
	// now add it to the list of intervals
	$intervals[$key] = $intervals_all[$position];
}
$intervals = array_intersect($intervals_all, $intervals);

// what radio boxes are selected?
if ($type == 'enharmonic') {
	$label_enhar = 'checked="checked"';
	$label_chrom = '';
} else {
	$label_chrom = 'checked="checked"';
	$label_enhar = '';
}
if ($display == 'universal') {
	$label_univ = 'checked="checked"';
	$label_note = '';
} else {
	$label_note = 'checked="checked"';
	$label_univ = '';
}

//
// START making the fretboard
$string_rows = array();
for ($string = 0; $string < $string_count; $string++) {
	$string_rows[$string] = generate_string($string,$scale,$tuning,$root,$interv,$display);
}
// END making the fretboard
//

// generate the strings for tuning and scale
$tuning_text = '';
$scale_text = '';
if ($_REQUEST['submitch']) {
	$tuning_text = $_REQUEST['tuning'];
	$scale_text = $_REQUEST['scale'];
} else {
	foreach ($tuning as $number) {
		$tuning_text .= $notes_all[$number] . ' ';
	}
	foreach ($scale as $key => $interva) {
		$scale_text .= substr($notes_all[$interva],0,-1) . ' ';
	}
	$tuning_text = substr($tuning_text,0,-1);
	$scale_text = substr($scale_text.$last,0,-1);
}

// generate a list of interval checkboxes
$i = 1;
$inter_checks = '';
$interv_text = '';
foreach ($intervals as $int_name) {
	// is this still on?
	if ($_SESSION[IN.$int_name] == 1) {
		$checked = 'checked="checked"';
	} else {
		$checked = '';
		$interv_text .= '&int_' . $int_name . '=off';
	}
	
	// make the checkbox
	$inter_checks .= '<input class="interval" type="checkbox" name="'.$int_name.'" id="int_'.$i.'" '.$checked.' onClick="submitOpt()" /><label for="int_'.$i.'">' . $int_name . '</label>';
	
	// newline?
	if ($i++ % 5 == 0) {
		$inter_checks .= '<br />';
	}
}

// now comes the database. 
$chord_data = get_tables($interv,$intervals);

// provide the link for passing this combination to someone else
$getlink = TH.'?tuning='.urlencode($tuning_text).'&scale='.urlencode($scale_text).$interv_text.'&display='.$display;

?>