<?php
/*
	Copyright 2010 Ketil Tunheim. This file is part of Magic Fretboard.

    Magic Fretboard is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Magic Fretboard is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

// parts one through three
include('scale_php.php');

//
// part four: generating the page itself
//
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="no" lang="no" dir="ltr">
<head>
  <title>Magic Fretboard</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <link rel="stylesheet" type="text/css" href="music.css" />
<script type="text/javascript" language="javascript">
function sendForm(new_root) {
	document.trans.newroot.value = new_root;
	document.trans.submit();
}
function resetScale() {
	document.change.reset.value = "y";
	document.change.submit();
}
function submitOpt() {
	document.intervals.submit();
}
</script>
</head>
<body>

<div class="block"><div class="info"><h4 class="line">Information</h4>
This script is designed to explore chords in any scale, with any number of strings tuned to anything. You'll start by specifying the tuning and scale. By default, it uses the highly unusual tuning <strong>E G# D# E G# D#</strong> and displays the Lydian scale of E, <strong>E F# G# A# B C# D#</strong> (<a href="#" onClick="resetScale()">reset</a>). Because I like it that way.
<p>When you have the desired tuning and scale, the <em>Change chord root</em> function will then let you see what chord formulas are provided for you in that scale, as well as how to play them. Lastly, you can perform a typical (chromatic) transposition to anywhere on the fretboard, and continue exploring chords there.</p></div>

<h4 class="line">Fretboard</h4>
Select what you'd like to do, and then click on the note you want to move to (the new root or key). To better understand and select the elements of the chord, I recommend displaying the scale in universal key. This also makes much more sense when changing the root.
<form name="trans" action="scale_view.php" method="post">

<p><input type="radio" <?=$label_enhar?> name="type" value="enharmonic" id="enharmonic" />
<label for="enharmonic" title="Shift the tonal center of the scale while keeping the same notes. Also works for just exploring chords of another scale degree than the tonic.">Change chord root</label>
<input type="radio" <?=$label_chrom?> name="type" value="chromatic" id="chromatic" />
<label for="chromatic" title="Move the key somewhere else, chromatically. It's the default kind of transposition.">Transpose to new key</label></p>
<input type="hidden" name="newroot" value="" />
<div class="fboard">
<?php
// generate the fretboard
for ($i = ($string_count-1); $i >= 0; $i--) {
	echo $string_rows[$i].NL;
}
?>
<img src="fretboard/fret_<?=$temperament?>.gif" />
</form>
</div>
<?php
if ($temperament == '31edo') echo '<br style="clear:both" />';
?>
<div class="show"><h4>Display intervals:</h4>
<form name="intervals" method="post" action="scale_view.php">
<?=$inter_checks?><br /><br />
<input type="radio" <?=$label_note?> name="disp_form" value="notes" id="notes" onClick="submitOpt()" />
<label for="notes">Show as notes</label><br />
<input type="radio" <?=$label_univ?> name="disp_form" value="universal" id="numbers" onClick="submitOpt()" />
<label for="numbers">Show as numbers (universal key)</label>
</form>
</div>
<br /><?=$info?>

<h4 class="line">Possible chords</h4>
Plot holes you might encounter: A 9 equals a 2, an 11 equals a 4, and a 13 equals a 6. In big chords, the 9, 11 and 5 are sometimes omitted. Those optional elements will be underlined below.
<p><form name="chords" action="scale_view.php" method="post">
<table class="chord_tbl">
<?=$chord_data?>
</table>
</form></p>

<div class="edit"><h4 class="line">Preferences</h4>
<form action="scale_view.php" name="change" method="post">
<label for="tuning">Tuning: </label><input class="longentry" type="text" name="tuning" id="tuning" value="<?=$tuning_text?>" /><br />
<label for="scale">Scale: </label><input class="longentry" type="text" name="scale" id="scale" value="<?=$scale_text?>" />
<input type="hidden" name="reset" value="n" />
<input type="submit" name="submitch" value="Update!" />
</form>
<?=$warning?>
</div>
<div class="edit"><h4 class="line">Link to this page</h4>
Want to link to this specific tuning and scale? Copy the link below:<br />
<input type="text" readonly="readonly" value="<?=$getlink?>" onClick="this.select()" />
</div>
</div>

</body>
</html>